# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from sick_safevisionary_msgs/ROIArray.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import sick_safevisionary_msgs.msg
import std_msgs.msg

class ROIArray(genpy.Message):
  _md5sum = "6edb1711881c9d8cd1fd4d58ffd3bf07"
  _type = "sick_safevisionary_msgs/ROIArray"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """# ROS msg definition for internal ROI_DATA struct
std_msgs/Header header
ROI[] rois

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: sick_safevisionary_msgs/ROI
# ROS msg definition for internal ROI struct
uint8 id
ROIObservationResultData result_data
ROIObservationSafetyData safety_data
uint16 distance_value

================================================================================
MSG: sick_safevisionary_msgs/ROIObservationResultData
# ROS msg definition for internal  ROI_DATA_RESULT struct
uint8 task_result
uint8 result_safe
uint8 result_valid
uint8 distance_valid
uint8 distance_safe

================================================================================
MSG: sick_safevisionary_msgs/ROIObservationSafetyData
# ROS msg definition for internal  ROI_DATA_SAFETY_DATA struct
uint8 invalid_due_to_invalid_pixels
uint8 invalid_due_to_variance
uint8 invalid_due_to_overexposure
uint8 invalid_due_to_underexposure
uint8 invalid_due_to_temporal_variance
uint8 invalid_due_to_outside_of_measurement_range
uint8 invalid_due_to_retro_reflector_interference
uint8 contamination_error
uint8 quality_class
uint8 slot_active
"""
  __slots__ = ['header','rois']
  _slot_types = ['std_msgs/Header','sick_safevisionary_msgs/ROI[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,rois

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ROIArray, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.rois is None:
        self.rois = []
    else:
      self.header = std_msgs.msg.Header()
      self.rois = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.rois)
      buff.write(_struct_I.pack(length))
      for val1 in self.rois:
        _x = val1.id
        buff.write(_get_struct_B().pack(_x))
        _v1 = val1.result_data
        _x = _v1
        buff.write(_get_struct_5B().pack(_x.task_result, _x.result_safe, _x.result_valid, _x.distance_valid, _x.distance_safe))
        _v2 = val1.safety_data
        _x = _v2
        buff.write(_get_struct_10B().pack(_x.invalid_due_to_invalid_pixels, _x.invalid_due_to_variance, _x.invalid_due_to_overexposure, _x.invalid_due_to_underexposure, _x.invalid_due_to_temporal_variance, _x.invalid_due_to_outside_of_measurement_range, _x.invalid_due_to_retro_reflector_interference, _x.contamination_error, _x.quality_class, _x.slot_active))
        _x = val1.distance_value
        buff.write(_get_struct_H().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.rois is None:
        self.rois = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.rois = []
      for i in range(0, length):
        val1 = sick_safevisionary_msgs.msg.ROI()
        start = end
        end += 1
        (val1.id,) = _get_struct_B().unpack(str[start:end])
        _v3 = val1.result_data
        _x = _v3
        start = end
        end += 5
        (_x.task_result, _x.result_safe, _x.result_valid, _x.distance_valid, _x.distance_safe,) = _get_struct_5B().unpack(str[start:end])
        _v4 = val1.safety_data
        _x = _v4
        start = end
        end += 10
        (_x.invalid_due_to_invalid_pixels, _x.invalid_due_to_variance, _x.invalid_due_to_overexposure, _x.invalid_due_to_underexposure, _x.invalid_due_to_temporal_variance, _x.invalid_due_to_outside_of_measurement_range, _x.invalid_due_to_retro_reflector_interference, _x.contamination_error, _x.quality_class, _x.slot_active,) = _get_struct_10B().unpack(str[start:end])
        start = end
        end += 2
        (val1.distance_value,) = _get_struct_H().unpack(str[start:end])
        self.rois.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.rois)
      buff.write(_struct_I.pack(length))
      for val1 in self.rois:
        _x = val1.id
        buff.write(_get_struct_B().pack(_x))
        _v5 = val1.result_data
        _x = _v5
        buff.write(_get_struct_5B().pack(_x.task_result, _x.result_safe, _x.result_valid, _x.distance_valid, _x.distance_safe))
        _v6 = val1.safety_data
        _x = _v6
        buff.write(_get_struct_10B().pack(_x.invalid_due_to_invalid_pixels, _x.invalid_due_to_variance, _x.invalid_due_to_overexposure, _x.invalid_due_to_underexposure, _x.invalid_due_to_temporal_variance, _x.invalid_due_to_outside_of_measurement_range, _x.invalid_due_to_retro_reflector_interference, _x.contamination_error, _x.quality_class, _x.slot_active))
        _x = val1.distance_value
        buff.write(_get_struct_H().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.rois is None:
        self.rois = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.rois = []
      for i in range(0, length):
        val1 = sick_safevisionary_msgs.msg.ROI()
        start = end
        end += 1
        (val1.id,) = _get_struct_B().unpack(str[start:end])
        _v7 = val1.result_data
        _x = _v7
        start = end
        end += 5
        (_x.task_result, _x.result_safe, _x.result_valid, _x.distance_valid, _x.distance_safe,) = _get_struct_5B().unpack(str[start:end])
        _v8 = val1.safety_data
        _x = _v8
        start = end
        end += 10
        (_x.invalid_due_to_invalid_pixels, _x.invalid_due_to_variance, _x.invalid_due_to_overexposure, _x.invalid_due_to_underexposure, _x.invalid_due_to_temporal_variance, _x.invalid_due_to_outside_of_measurement_range, _x.invalid_due_to_retro_reflector_interference, _x.contamination_error, _x.quality_class, _x.slot_active,) = _get_struct_10B().unpack(str[start:end])
        start = end
        end += 2
        (val1.distance_value,) = _get_struct_H().unpack(str[start:end])
        self.rois.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_10B = None
def _get_struct_10B():
    global _struct_10B
    if _struct_10B is None:
        _struct_10B = struct.Struct("<10B")
    return _struct_10B
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_5B = None
def _get_struct_5B():
    global _struct_5B
    if _struct_5B is None:
        _struct_5B = struct.Struct("<5B")
    return _struct_5B
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_H = None
def _get_struct_H():
    global _struct_H
    if _struct_H is None:
        _struct_H = struct.Struct("<H")
    return _struct_H
